"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = DSQL_USER_DB_HANDLER;
const conn_db_handler_1 = __importDefault(require("../../db/conn-db-handler"));
/**
 * # DSQL user read-only DB handler
 */
function DSQL_USER_DB_HANDLER(_a) {
    return __awaiter(this, arguments, void 0, function* ({ paradigm, queryString, queryValues, }) {
        try {
            switch (paradigm) {
                case "Read Only":
                    return yield (0, conn_db_handler_1.default)(global.DSQL_READ_ONLY_DB_CONN, queryString, queryValues);
                case "Full Access":
                    return yield (0, conn_db_handler_1.default)(global.DSQL_FULL_ACCESS_DB_CONN, queryString, queryValues);
                case "FA":
                    return yield (0, conn_db_handler_1.default)(global.DSQL_FULL_ACCESS_DB_CONN, queryString, queryValues);
                default:
                    return null;
            }
        }
        catch (error) {
            console.log(`DSQL_USER_DB_HANDLER Error: ${error.message}`);
            return null;
        }
        // try {
        //     return new Promise((resolve, reject) => {
        //         const fullAccess = paradigm?.match(/full.access|^fa$/i)
        //             ? true
        //             : false;
        //         try {
        //             if (fullAccess) {
        //                 DSQL_USER = mysql({
        //                     config: {
        //                         host: process.env.DSQL_DB_HOST,
        //                         user: process.env.DSQL_DB_FULL_ACCESS_USERNAME,
        //                         password: process.env.DSQL_DB_FULL_ACCESS_PASSWORD,
        //                         database: database,
        //                         ssl: grabDbSSL(),
        //                     },
        //                 });
        //             } else {
        //                 DSQL_USER = mysql({
        //                     config: {
        //                         host: process.env.DSQL_DB_HOST,
        //                         user: process.env.DSQL_DB_READ_ONLY_USERNAME,
        //                         password: process.env.DSQL_DB_READ_ONLY_PASSWORD,
        //                         database: database,
        //                         ssl: grabDbSSL(),
        //                     },
        //                 });
        //             }
        //             /**
        //              * ### Run query Function
        //              * @param {any} results
        //              */
        //             function runQuery(results: any) {
        //                 DSQL_USER.end();
        //                 resolve(JSON.parse(JSON.stringify(results)));
        //             }
        //             /**
        //              * ### Query Error
        //              * @param {any} err
        //              */
        //             function queryError(err: any) {
        //                 DSQL_USER.end();
        //                 resolve({
        //                     error: err.message,
        //                     queryStringGenerated: queryString,
        //                     queryValuesGenerated: queryValues,
        //                     sql: err.sql,
        //                 });
        //             }
        //             if (
        //                 queryValues &&
        //                 Array.isArray(queryValues) &&
        //                 queryValues[0]
        //             ) {
        //                 DSQL_USER.query(queryString, queryValues)
        //                     .then(runQuery)
        //                     .catch(queryError);
        //             } else {
        //                 DSQL_USER.query(queryString)
        //                     .then(runQuery)
        //                     .catch(queryError);
        //             }
        //             ////////////////////////////////////////
        //         } catch (/** @type {any} */ error: any) {
        //             ////////////////////////////////////////
        //             fs.appendFileSync(
        //                 "./.tmp/dbErrorLogs.txt",
        //                 error.message + "\n" + Date() + "\n\n\n",
        //                 "utf8"
        //             );
        //             resolve({
        //                 error: error.message,
        //             });
        //         }
        //     });
        // } catch (/** @type {any} */ error: any) {
        //     return {
        //         success: false,
        //         error: error.message,
        //     };
        // }
    });
}
