"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = NO_DB_HANDLER;
/**
 * # DSQL user read-only DB handler
 */
function NO_DB_HANDLER(...args) {
    const NO_DB = global.DSQL_DB_CONN;
    try {
        return new Promise((resolve, reject) => {
            NO_DB.query(...args)
                .then((results) => {
                NO_DB.end();
                resolve(JSON.parse(JSON.stringify(results)));
            })
                .catch((err) => {
                NO_DB.end();
                resolve({
                    error: err.message,
                    sql: err.sql,
                });
            });
        });
    }
    catch (error) {
        return {
            success: false,
            error: error.message,
        };
    }
}
